using System;
using System.Collections.Generic;
using System.Text;

#pragma warning disable CS1591

namespace $rootnamespace$.Bd 
{
	public static partial class Ggclipr_tch_pkg
	{
					#region ACTUALIZAR
			
			[Nombre("GGCLIPR_TCH_PKG.ACTUALIZAR")]
						public delegate void __ACTUALIZAR_VVVNVVNVDVoRoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4000)] string p_tipo_operacion, 
							[VARCHAR2(4000)] string p_empgrupo_cod, 
							[VARCHAR2(4000)] string p_tip_vc, 
							[NUMBER] decimal? p_cod, 
							[VARCHAR2(4000)] string p_rsocial_cod, 
							[VARCHAR2(4000)] string p_nombre, 
							[NUMBER] decimal? p_gvagente_cod, 
							[VARCHAR2(4000)] string p_web, 
							[DATE] DateTime? p_f_alta, 
							[VARCHAR2(4000)] string p_opcion, 
							[ROWID] out string p_rowid, 
							[VARCHAR2(4000)] out string p_mensaje_info, 
							[VARCHAR2(4000)] out string p_mensaje_error);

						/// <summary>
			/// Llama a ACTUALIZAR.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versin sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void ACTUALIZAR(
				System.Data.IDbTransaction p_transaccion, 
				string p_tipo_operacion, 
				string p_empgrupo_cod, 
				string p_tip_vc, 
				decimal? p_cod, 
				string p_rsocial_cod, 
				string p_nombre, 
				decimal? p_gvagente_cod, 
				string p_web, 
				DateTime? p_f_alta, 
				string p_opcion, 
				out string p_rowid, 
				out string p_mensaje_info, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__ACTUALIZAR_VVVNVVNVDVoRoVoV v_actualizar;
				try {
					v_actualizar = Funcion.Crear<__ACTUALIZAR_VVVNVVNVDVoRoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.ACTUALIZAR");
				}
								try {
				v_actualizar(p_transaccion, 
					p_tipo_operacion, 
					p_empgrupo_cod, 
					p_tip_vc, 
					p_cod, 
					p_rsocial_cod, 
					p_nombre, 
					p_gvagente_cod, 
					p_web, 
					p_f_alta, 
					p_opcion, 
					out p_rowid, 
					out p_mensaje_info, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.ACTUALIZAR");
				}
							}
			
							/// <summary>
				/// Llama a ACTUALIZAR y eleva una excepcin en caso de error. Utiliza la versin 
				/// sobrecargada (con el parmetro p_mensaje_error) para llamar a la versin original.
				/// </summary>
				public static void ACTUALIZAR(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4000)] string p_tipo_operacion, 
					[VARCHAR2(4000)] string p_empgrupo_cod, 
					[VARCHAR2(4000)] string p_tip_vc, 
					[NUMBER] decimal? p_cod, 
					[VARCHAR2(4000)] string p_rsocial_cod, 
					[VARCHAR2(4000)] string p_nombre, 
					[NUMBER] decimal? p_gvagente_cod, 
					[VARCHAR2(4000)] string p_web, 
					[DATE] DateTime? p_f_alta, 
					[VARCHAR2(4000)] string p_opcion, 
					[ROWID] out string p_rowid, 
					[VARCHAR2(4000)] out string p_mensaje_info)
				{
												string copia_p_rowid;
										    							string copia_p_mensaje_info;
										    
					string p_mensaje_error;

					ACTUALIZAR(p_transaccion, 
						p_tipo_operacion, 
						p_empgrupo_cod, 
						p_tip_vc, 
						p_cod, 
						p_rsocial_cod, 
						p_nombre, 
						p_gvagente_cod, 
						p_web, 
						p_f_alta, 
						p_opcion, 
						out copia_p_rowid, 
						out copia_p_mensaje_info,
						out p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
						throw new SpyroException(p_mensaje_error, "GGCLIPR_TCH_PKG.ACTUALIZAR");

											p_rowid = copia_p_rowid;
				    						p_mensaje_info = copia_p_mensaje_info;
				    					
									}	
			
			#endregion

					#region CREA_CLIENTE
			
			[Nombre("GGCLIPR_TCH_PKG.CREA_CLIENTE")]
						public delegate void __CREA_CLIENTE_VVVVVoNoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(40)] string p_nombre, 
							[VARCHAR2(20)] string p_rsocial_cod, 
							[VARCHAR2(40)] string p_web, 
							[NUMBER(8)] out int? p_cod, 
							[VARCHAR2(4000)] out string p_mensaje_info, 
							[VARCHAR2(4000)] out string p_mensaje_error);

						/// <summary>
			/// Llama a CREA_CLIENTE.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versin sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void CREA_CLIENTE(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_nombre, 
				string p_rsocial_cod, 
				string p_web, 
				out int? p_cod, 
				out string p_mensaje_info, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__CREA_CLIENTE_VVVVVoNoVoV v_crea_cliente;
				try {
					v_crea_cliente = Funcion.Crear<__CREA_CLIENTE_VVVVVoNoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.CREA_CLIENTE");
				}
								try {
				v_crea_cliente(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_nombre, 
					p_rsocial_cod, 
					p_web, 
					out p_cod, 
					out p_mensaje_info, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.CREA_CLIENTE");
				}
							}
			
							/// <summary>
				/// Llama a CREA_CLIENTE y eleva una excepcin en caso de error. Utiliza la versin 
				/// sobrecargada (con el parmetro p_mensaje_error) para llamar a la versin original.
				/// </summary>
				public static void CREA_CLIENTE(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(40)] string p_nombre, 
					[VARCHAR2(20)] string p_rsocial_cod, 
					[VARCHAR2(40)] string p_web, 
					[NUMBER(8)] out int? p_cod, 
					[VARCHAR2(4000)] out string p_mensaje_info)
				{
												int? copia_p_cod;
										    							string copia_p_mensaje_info;
										    
					string p_mensaje_error;

					CREA_CLIENTE(p_transaccion, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_nombre, 
						p_rsocial_cod, 
						p_web, 
						out copia_p_cod, 
						out copia_p_mensaje_info,
						out p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
						throw new SpyroException(p_mensaje_error, "GGCLIPR_TCH_PKG.CREA_CLIENTE");

											p_cod = copia_p_cod;
				    						p_mensaje_info = copia_p_mensaje_info;
				    					
									}	
			
			#endregion

					#region DAME_HIST_SN
			
			[Nombre("GGCLIPR_TCH_PKG.DAME_HIST_SN")]
						[return: VARCHAR2(1)]
						public delegate string __DAME_HIST_SN_ND(
							System.Data.IDbTransaction p_transaccion, 
							[NUMBER(8)] int? p_ggclipr_cod, 
							[DATE] DateTime? p_f_baja);

						/// <summary>
			/// Llama a DAME_HIST_SN.
						/// </summary>
			public static string DAME_HIST_SN(
				System.Data.IDbTransaction p_transaccion, 
				int? p_ggclipr_cod, 
				DateTime? p_f_baja,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_HIST_SN_ND v_dame_hist_sn;
				try {
					v_dame_hist_sn = Funcion.Crear<__DAME_HIST_SN_ND>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_HIST_SN");
				}
									string v_resultado;
								try {
				v_resultado = v_dame_hist_sn(p_transaccion, 
					p_ggclipr_cod, 
					p_f_baja);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_HIST_SN");
				}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_LISTA_CLI_CERCANO
			 
					public interface IDAME_LISTA_CLI_CERCANO 
{
			int? GGCLIPR_COD { get; }
			string GGCLIPR_NOMBRE { get; }
			string RSOCDIR_COD { get; }
			string NOMBRE { get; }
			string DIR { get; }
			string COD_POSTAL { get; }
			string PAISES_COD { get; }
			string PAISES_NOMBRE { get; }
			string PROVI_COD { get; }
			string PROVI_NOMBRE { get; }
			string POBLAC_COD { get; }
			string POBLAC_NOM { get; }
			string TELEFONOS { get; }
			string TELEFAX { get; }
			string E_MAIL { get; }
			string LONGITUD { get; }
			string LATITUD { get; }
			string TIPO_DIR { get; }
	}
			
			[Nombre("GGCLIPR_TCH_PKG.DAME_LISTA_CLI_CERCANO")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_LISTA_CLI_CERCANO> __DAME_LISTA_CLI_CERCANO_VVNVNV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER(8)] int? p_ggclipr_cod, 
							[VARCHAR2(4000)] string p_tipo_dir, 
							[NUMBER] decimal? p_km, 
							[VARCHAR2(4000)] string p_opciones);

						/// <summary>
			/// Llama a DAME_LISTA_CLI_CERCANO.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_LISTA_CLI_CERCANO> DAME_LISTA_CLI_CERCANO(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				string p_tipo_dir, 
				decimal? p_km, 
				string p_opciones,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_LISTA_CLI_CERCANO_VVNVNV v_dame_lista_cli_cercano;
				try {
					v_dame_lista_cli_cercano = Funcion.Crear<__DAME_LISTA_CLI_CERCANO_VVNVNV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_LISTA_CLI_CERCANO");
				}
									System.Collections.Generic.IEnumerable<IDAME_LISTA_CLI_CERCANO> v_resultado;
								try {
				v_resultado = v_dame_lista_cli_cercano(p_transaccion, 
					p_empgrupo_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_tipo_dir, 
					p_km, 
					p_opciones);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_LISTA_CLI_CERCANO");
				}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_LISTA_CLIENTES
			 
					public interface IDAME_LISTA_CLIENTES 
{
			int? COD { get; }
			string NOMBRE { get; }
			string RSOCIAL_COD { get; }
			string RSOCIAL_NOMBRE { get; }
			string WEB { get; }
			string GGESTADO_COD { get; }
			string GGESTADO_DESCRIP { get; }
			string GGESTADO_COLOR_FONDO { get; }
			DateTime? F_ALTA { get; }
			DateTime? F_BAJA { get; }
			string HIST_SN { get; }
			string RSOCDIR_FAC { get; }
			string RSOCDIR_ENV { get; }
			string RSOCDIR_PAG { get; }
			string RSOCDIR_COR { get; }
			string GATARIFTIP_DEF { get; }
			string GATARIFTIP_DEF_DESCRIP { get; }
			int? GVAGENTE_COD { get; }
			string GVAGENTE_NOMBRE { get; }
			int? GVAGENTE_DEL { get; }
			string GVAGENTE_DEL_NOMBRE { get; }
			string PATH_LOGO { get; }
			decimal? RIESGOCON { get; }
			string TELEFONOS { get; }
			string E_MAIL { get; }
			int? VISITAS_N_VISI_TOTAL { get; }
			DateTime? VISITAS_F_VISI_ULT { get; }
			int? VISITAS_N_INFORME_VISI_ULT { get; }
			string VISITAS_USRNOM_VISI_ULT { get; }
			string VISITAS_DESCRIPTOR_VISI_ULT { get; }
	}
			
			[Nombre("GGCLIPR_TCH_PKG.DAME_LISTA_CLIENTES")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_LISTA_CLIENTES> __DAME_LISTA_CLIENTES_VVVVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(4000)] string p_ggclipr_cod_cond, 
							[VARCHAR2(4000)] string p_visitas_sn, 
							[VARCHAR2(30)] string p_user, 
							[VARCHAR2(4000)] string p_opciones);

						/// <summary>
			/// Llama a DAME_LISTA_CLIENTES.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_LISTA_CLIENTES> DAME_LISTA_CLIENTES(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_ggclipr_cod_cond, 
				string p_visitas_sn, 
				string p_user, 
				string p_opciones,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_LISTA_CLIENTES_VVVVVV v_dame_lista_clientes;
				try {
					v_dame_lista_clientes = Funcion.Crear<__DAME_LISTA_CLIENTES_VVVVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_LISTA_CLIENTES");
				}
									System.Collections.Generic.IEnumerable<IDAME_LISTA_CLIENTES> v_resultado;
								try {
				v_resultado = v_dame_lista_clientes(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_ggclipr_cod_cond, 
					p_visitas_sn, 
					p_user, 
					p_opciones);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_LISTA_CLIENTES");
				}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_LISTA_GGCLIPROBS
			 
					public interface IDAME_LISTA_GGCLIPROBS 
{
			string GGOBSTIP_COD { get; }
			string GGOBSTIP_DESCRIP { get; }
			string COMENTARIO { get; }
	}
			
			[Nombre("GGCLIPR_TCH_PKG.DAME_LISTA_GGCLIPROBS")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_LISTA_GGCLIPROBS> __DAME_LISTA_GGCLIPROBS_VVVNVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER(8)] int? p_ggclipr_cod, 
							[VARCHAR2(30)] string p_user, 
							[VARCHAR2(4000)] string p_opciones);

						/// <summary>
			/// Llama a DAME_LISTA_GGCLIPROBS.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_LISTA_GGCLIPROBS> DAME_LISTA_GGCLIPROBS(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				string p_user, 
				string p_opciones,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_LISTA_GGCLIPROBS_VVVNVV v_dame_lista_ggcliprobs;
				try {
					v_dame_lista_ggcliprobs = Funcion.Crear<__DAME_LISTA_GGCLIPROBS_VVVNVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_LISTA_GGCLIPROBS");
				}
									System.Collections.Generic.IEnumerable<IDAME_LISTA_GGCLIPROBS> v_resultado;
								try {
				v_resultado = v_dame_lista_ggcliprobs(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_user, 
					p_opciones);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_LISTA_GGCLIPROBS");
				}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_LISTA_RSOCDIRCLI
			 
					public interface IDAME_LISTA_RSOCDIRCLI 
{
			int? GGCLIPR_COD { get; }
			string GGCLIPR_NOMBRE { get; }
			string RSOCDIR_COD { get; }
			string NOMBRE { get; }
			string DIR { get; }
			string COD_POSTAL { get; }
			string PAISES_COD { get; }
			string PAISES_NOMBRE { get; }
			string PROVI_COD { get; }
			string PROVI_NOMBRE { get; }
			string POBLAC_COD { get; }
			string POBLAC_NOM { get; }
			string TELEFONOS { get; }
			string TELEFAX { get; }
			string E_MAIL { get; }
			string LONGITUD { get; }
			string LATITUD { get; }
			string TIPO_DIR { get; }
	}
			
			[Nombre("GGCLIPR_TCH_PKG.DAME_LISTA_RSOCDIRCLI")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_LISTA_RSOCDIRCLI> __DAME_LISTA_RSOCDIRCLI_VVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[VARCHAR2(4000)] string p_opciones);

						/// <summary>
			/// Llama a DAME_LISTA_RSOCDIRCLI.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_LISTA_RSOCDIRCLI> DAME_LISTA_RSOCDIRCLI(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_tip_vc, 
				string p_opciones,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_LISTA_RSOCDIRCLI_VVV v_dame_lista_rsocdircli;
				try {
					v_dame_lista_rsocdircli = Funcion.Crear<__DAME_LISTA_RSOCDIRCLI_VVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_LISTA_RSOCDIRCLI");
				}
									System.Collections.Generic.IEnumerable<IDAME_LISTA_RSOCDIRCLI> v_resultado;
								try {
				v_resultado = v_dame_lista_rsocdircli(p_transaccion, 
					p_empgrupo_cod, 
					p_tip_vc, 
					p_opciones);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_LISTA_RSOCDIRCLI");
				}
									return v_resultado;
							}
			
			
			#endregion

					#region DAME_RIESGO_CLIPR
			
			[Nombre("GGCLIPR_TCH_PKG.DAME_RIESGO_CLIPR")]
						public delegate void __DAME_RIESGO_CLIPR_VVVNoNoNoNoNoNoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER(8)] int? p_ggclipr_cod, 
							[NUMBER(14, 4)] out decimal? p_cobro_pte, 
							[NUMBER(14, 4)] out decimal? p_cobro_retrasado, 
							[NUMBER(14, 4)] out decimal? p_cobro_impagado, 
							[NUMBER(14, 2)] out decimal? p_pedidos_ptes, 
							[NUMBER(14, 2)] out decimal? p_ofer_ptes, 
							[VARCHAR2(4000)] out string p_mensaje_error);

						/// <summary>
			/// Llama a DAME_RIESGO_CLIPR.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versin sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void DAME_RIESGO_CLIPR(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				out decimal? p_cobro_pte, 
				out decimal? p_cobro_retrasado, 
				out decimal? p_cobro_impagado, 
				out decimal? p_pedidos_ptes, 
				out decimal? p_ofer_ptes, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_RIESGO_CLIPR_VVVNoNoNoNoNoNoV v_dame_riesgo_clipr;
				try {
					v_dame_riesgo_clipr = Funcion.Crear<__DAME_RIESGO_CLIPR_VVVNoNoNoNoNoNoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_RIESGO_CLIPR");
				}
								try {
				v_dame_riesgo_clipr(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					out p_cobro_pte, 
					out p_cobro_retrasado, 
					out p_cobro_impagado, 
					out p_pedidos_ptes, 
					out p_ofer_ptes, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_RIESGO_CLIPR");
				}
							}
			
							/// <summary>
				/// Llama a DAME_RIESGO_CLIPR y eleva una excepcin en caso de error. Utiliza la versin 
				/// sobrecargada (con el parmetro p_mensaje_error) para llamar a la versin original.
				/// </summary>
				public static void DAME_RIESGO_CLIPR(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[NUMBER(8)] int? p_ggclipr_cod, 
					[NUMBER(14, 4)] out decimal? p_cobro_pte, 
					[NUMBER(14, 4)] out decimal? p_cobro_retrasado, 
					[NUMBER(14, 4)] out decimal? p_cobro_impagado, 
					[NUMBER(14, 2)] out decimal? p_pedidos_ptes, 
					[NUMBER(14, 2)] out decimal? p_ofer_ptes)
				{
												decimal? copia_p_cobro_pte;
										    							decimal? copia_p_cobro_retrasado;
										    							decimal? copia_p_cobro_impagado;
										    							decimal? copia_p_pedidos_ptes;
										    							decimal? copia_p_ofer_ptes;
										    
					string p_mensaje_error;

					DAME_RIESGO_CLIPR(p_transaccion, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_tip_vc, 
						p_ggclipr_cod, 
						out copia_p_cobro_pte, 
						out copia_p_cobro_retrasado, 
						out copia_p_cobro_impagado, 
						out copia_p_pedidos_ptes, 
						out copia_p_ofer_ptes,
						out p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
						throw new SpyroException(p_mensaje_error, "GGCLIPR_TCH_PKG.DAME_RIESGO_CLIPR");

											p_cobro_pte = copia_p_cobro_pte;
				    						p_cobro_retrasado = copia_p_cobro_retrasado;
				    						p_cobro_impagado = copia_p_cobro_impagado;
				    						p_pedidos_ptes = copia_p_pedidos_ptes;
				    						p_ofer_ptes = copia_p_ofer_ptes;
				    					
									}	
			
			#endregion

					#region DAME_SITUACION_RIESGO
			 
					public interface IDAME_SITUACION_RIESGO 
{
			int? GGCLIPR_COD { get; }
			decimal? COBRO_PTE { get; }
			decimal? COBRO_RETRASADO { get; }
			decimal? COBRO_IMPAGADO { get; }
			decimal? PEDIDOS_PTES { get; }
			decimal? OFER_PTES { get; }
	}
			
			[Nombre("GGCLIPR_TCH_PKG.DAME_SITUACION_RIESGO")]
						public delegate System.Collections.Generic.IEnumerable<IDAME_SITUACION_RIESGO> __DAME_SITUACION_RIESGO_VVVN(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER(8)] int? p_ggclipr_cod);

						/// <summary>
			/// Llama a DAME_SITUACION_RIESGO.
						/// </summary>
			public static System.Collections.Generic.IEnumerable<IDAME_SITUACION_RIESGO> DAME_SITUACION_RIESGO(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DAME_SITUACION_RIESGO_VVVN v_dame_situacion_riesgo;
				try {
					v_dame_situacion_riesgo = Funcion.Crear<__DAME_SITUACION_RIESGO_VVVN>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_SITUACION_RIESGO");
				}
									System.Collections.Generic.IEnumerable<IDAME_SITUACION_RIESGO> v_resultado;
								try {
				v_resultado = v_dame_situacion_riesgo(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_tip_vc, 
					p_ggclipr_cod);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DAME_SITUACION_RIESGO");
				}
									return v_resultado;
							}
			
			
			#endregion

					#region DATOS_CALCULADOS
			
			[Nombre("GGCLIPR_TCH_PKG.DATOS_CALCULADOS")]
						public delegate void __DATOS_CALCULADOS_VoDoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4000)] string p_id, 
							[DATE] out DateTime? p_last_visited, 
							[VARCHAR2(4000)] out string p_mensaje_error);

						/// <summary>
			/// Llama a DATOS_CALCULADOS.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versin sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void DATOS_CALCULADOS(
				System.Data.IDbTransaction p_transaccion, 
				string p_id, 
				out DateTime? p_last_visited, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DATOS_CALCULADOS_VoDoV v_datos_calculados;
				try {
					v_datos_calculados = Funcion.Crear<__DATOS_CALCULADOS_VoDoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_CALCULADOS");
				}
								try {
				v_datos_calculados(p_transaccion, 
					p_id, 
					out p_last_visited, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_CALCULADOS");
				}
							}
			
							/// <summary>
				/// Llama a DATOS_CALCULADOS y eleva una excepcin en caso de error. Utiliza la versin 
				/// sobrecargada (con el parmetro p_mensaje_error) para llamar a la versin original.
				/// </summary>
				public static void DATOS_CALCULADOS(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4000)] string p_id, 
					[DATE] out DateTime? p_last_visited)
				{
												DateTime? copia_p_last_visited;
										    
					string p_mensaje_error;

					DATOS_CALCULADOS(p_transaccion, 
						p_id, 
						out copia_p_last_visited,
						out p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
						throw new SpyroException(p_mensaje_error, "GGCLIPR_TCH_PKG.DATOS_CALCULADOS");

											p_last_visited = copia_p_last_visited;
				    					
									}	
			
			#endregion

					#region DATOS_CALCULADOS_EMPRESA
			
			[Nombre("GGCLIPR_TCH_PKG.DATOS_CALCULADOS_EMPRESA")]
						public delegate void __DATOS_CALCULADOS_EMPRESA_VoNoNoNoNoNoNoNoNoNoDoNoNoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4000)] string p_id, 
							[NUMBER] out decimal? p_number_of_opportunities, 
							[NUMBER] out decimal? p_amount_of_opportunities, 
							[NUMBER] out decimal? p_number_of_quotes, 
							[NUMBER] out decimal? p_amount_of_quotes, 
							[NUMBER] out decimal? p_number_of_orders, 
							[NUMBER] out decimal? p_amount_of_orders, 
							[NUMBER] out decimal? p_total_unpaids, 
							[NUMBER] out decimal? p_delayed_receivables, 
							[NUMBER] out decimal? p_receivable, 
							[DATE] out DateTime? p_last_order, 
							[NUMBER] out decimal? p_assumed_risk, 
							[NUMBER] out decimal? p_current_risk, 
							[VARCHAR2(4000)] out string p_mensaje_error);

						/// <summary>
			/// Llama a DATOS_CALCULADOS_EMPRESA.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versin sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void DATOS_CALCULADOS_EMPRESA(
				System.Data.IDbTransaction p_transaccion, 
				string p_id, 
				out decimal? p_number_of_opportunities, 
				out decimal? p_amount_of_opportunities, 
				out decimal? p_number_of_quotes, 
				out decimal? p_amount_of_quotes, 
				out decimal? p_number_of_orders, 
				out decimal? p_amount_of_orders, 
				out decimal? p_total_unpaids, 
				out decimal? p_delayed_receivables, 
				out decimal? p_receivable, 
				out DateTime? p_last_order, 
				out decimal? p_assumed_risk, 
				out decimal? p_current_risk, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DATOS_CALCULADOS_EMPRESA_VoNoNoNoNoNoNoNoNoNoDoNoNoV v_datos_calculados_empresa;
				try {
					v_datos_calculados_empresa = Funcion.Crear<__DATOS_CALCULADOS_EMPRESA_VoNoNoNoNoNoNoNoNoNoDoNoNoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_CALCULADOS_EMPRESA");
				}
								try {
				v_datos_calculados_empresa(p_transaccion, 
					p_id, 
					out p_number_of_opportunities, 
					out p_amount_of_opportunities, 
					out p_number_of_quotes, 
					out p_amount_of_quotes, 
					out p_number_of_orders, 
					out p_amount_of_orders, 
					out p_total_unpaids, 
					out p_delayed_receivables, 
					out p_receivable, 
					out p_last_order, 
					out p_assumed_risk, 
					out p_current_risk, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_CALCULADOS_EMPRESA");
				}
							}
			
							/// <summary>
				/// Llama a DATOS_CALCULADOS_EMPRESA y eleva una excepcin en caso de error. Utiliza la versin 
				/// sobrecargada (con el parmetro p_mensaje_error) para llamar a la versin original.
				/// </summary>
				public static void DATOS_CALCULADOS_EMPRESA(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4000)] string p_id, 
					[NUMBER] out decimal? p_number_of_opportunities, 
					[NUMBER] out decimal? p_amount_of_opportunities, 
					[NUMBER] out decimal? p_number_of_quotes, 
					[NUMBER] out decimal? p_amount_of_quotes, 
					[NUMBER] out decimal? p_number_of_orders, 
					[NUMBER] out decimal? p_amount_of_orders, 
					[NUMBER] out decimal? p_total_unpaids, 
					[NUMBER] out decimal? p_delayed_receivables, 
					[NUMBER] out decimal? p_receivable, 
					[DATE] out DateTime? p_last_order, 
					[NUMBER] out decimal? p_assumed_risk, 
					[NUMBER] out decimal? p_current_risk)
				{
												decimal? copia_p_number_of_opportunities;
										    							decimal? copia_p_amount_of_opportunities;
										    							decimal? copia_p_number_of_quotes;
										    							decimal? copia_p_amount_of_quotes;
										    							decimal? copia_p_number_of_orders;
										    							decimal? copia_p_amount_of_orders;
										    							decimal? copia_p_total_unpaids;
										    							decimal? copia_p_delayed_receivables;
										    							decimal? copia_p_receivable;
										    							DateTime? copia_p_last_order;
										    							decimal? copia_p_assumed_risk;
										    							decimal? copia_p_current_risk;
										    
					string p_mensaje_error;

					DATOS_CALCULADOS_EMPRESA(p_transaccion, 
						p_id, 
						out copia_p_number_of_opportunities, 
						out copia_p_amount_of_opportunities, 
						out copia_p_number_of_quotes, 
						out copia_p_amount_of_quotes, 
						out copia_p_number_of_orders, 
						out copia_p_amount_of_orders, 
						out copia_p_total_unpaids, 
						out copia_p_delayed_receivables, 
						out copia_p_receivable, 
						out copia_p_last_order, 
						out copia_p_assumed_risk, 
						out copia_p_current_risk,
						out p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
						throw new SpyroException(p_mensaje_error, "GGCLIPR_TCH_PKG.DATOS_CALCULADOS_EMPRESA");

											p_number_of_opportunities = copia_p_number_of_opportunities;
				    						p_amount_of_opportunities = copia_p_amount_of_opportunities;
				    						p_number_of_quotes = copia_p_number_of_quotes;
				    						p_amount_of_quotes = copia_p_amount_of_quotes;
				    						p_number_of_orders = copia_p_number_of_orders;
				    						p_amount_of_orders = copia_p_amount_of_orders;
				    						p_total_unpaids = copia_p_total_unpaids;
				    						p_delayed_receivables = copia_p_delayed_receivables;
				    						p_receivable = copia_p_receivable;
				    						p_last_order = copia_p_last_order;
				    						p_assumed_risk = copia_p_assumed_risk;
				    						p_current_risk = copia_p_current_risk;
				    					
									}	
			
			#endregion

					#region DATOS_CROPOR
			
			[Nombre("GGCLIPR_TCH_PKG.DATOS_CROPOR")]
						public delegate void __DATOS_CROPOR_VVNVVDVVVoNoNoNoNoDoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER(8)] int? p_ggclipr_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(8)] string p_croportip_cod, 
							[DATE] DateTime? p_f_referencia, 
							[VARCHAR2(4000)] string p_periodo, 
							[VARCHAR2(4000)] string p_calc_i_opor_pdtes, 
							[VARCHAR2(4000)] string p_opcion, 
							[NUMBER] out decimal? p_n_opor_total, 
							[NUMBER] out decimal? p_i_opor_total, 
							[NUMBER] out decimal? p_n_opor_pdtes, 
							[NUMBER] out decimal? p_i_opor_pdtes, 
							[DATE] out DateTime? p_f_opor_ult, 
							[VARCHAR2(4000)] out string p_mensaje_error);

						/// <summary>
			/// Llama a DATOS_CROPOR.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versin sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void DATOS_CROPOR(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				string p_emp_cod, 
				string p_croportip_cod, 
				DateTime? p_f_referencia, 
				string p_periodo, 
				string p_calc_i_opor_pdtes, 
				string p_opcion, 
				out decimal? p_n_opor_total, 
				out decimal? p_i_opor_total, 
				out decimal? p_n_opor_pdtes, 
				out decimal? p_i_opor_pdtes, 
				out DateTime? p_f_opor_ult, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DATOS_CROPOR_VVNVVDVVVoNoNoNoNoDoV v_datos_cropor;
				try {
					v_datos_cropor = Funcion.Crear<__DATOS_CROPOR_VVNVVDVVVoNoNoNoNoDoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_CROPOR");
				}
								try {
				v_datos_cropor(p_transaccion, 
					p_empgrupo_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_emp_cod, 
					p_croportip_cod, 
					p_f_referencia, 
					p_periodo, 
					p_calc_i_opor_pdtes, 
					p_opcion, 
					out p_n_opor_total, 
					out p_i_opor_total, 
					out p_n_opor_pdtes, 
					out p_i_opor_pdtes, 
					out p_f_opor_ult, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_CROPOR");
				}
							}
			
							/// <summary>
				/// Llama a DATOS_CROPOR y eleva una excepcin en caso de error. Utiliza la versin 
				/// sobrecargada (con el parmetro p_mensaje_error) para llamar a la versin original.
				/// </summary>
				public static void DATOS_CROPOR(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[NUMBER(8)] int? p_ggclipr_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(8)] string p_croportip_cod, 
					[DATE] DateTime? p_f_referencia, 
					[VARCHAR2(4000)] string p_periodo, 
					[VARCHAR2(4000)] string p_calc_i_opor_pdtes, 
					[VARCHAR2(4000)] string p_opcion, 
					[NUMBER] out decimal? p_n_opor_total, 
					[NUMBER] out decimal? p_i_opor_total, 
					[NUMBER] out decimal? p_n_opor_pdtes, 
					[NUMBER] out decimal? p_i_opor_pdtes, 
					[DATE] out DateTime? p_f_opor_ult)
				{
												decimal? copia_p_n_opor_total;
										    							decimal? copia_p_i_opor_total;
										    							decimal? copia_p_n_opor_pdtes;
										    							decimal? copia_p_i_opor_pdtes;
										    							DateTime? copia_p_f_opor_ult;
										    
					string p_mensaje_error;

					DATOS_CROPOR(p_transaccion, 
						p_empgrupo_cod, 
						p_tip_vc, 
						p_ggclipr_cod, 
						p_emp_cod, 
						p_croportip_cod, 
						p_f_referencia, 
						p_periodo, 
						p_calc_i_opor_pdtes, 
						p_opcion, 
						out copia_p_n_opor_total, 
						out copia_p_i_opor_total, 
						out copia_p_n_opor_pdtes, 
						out copia_p_i_opor_pdtes, 
						out copia_p_f_opor_ult,
						out p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
						throw new SpyroException(p_mensaje_error, "GGCLIPR_TCH_PKG.DATOS_CROPOR");

											p_n_opor_total = copia_p_n_opor_total;
				    						p_i_opor_total = copia_p_i_opor_total;
				    						p_n_opor_pdtes = copia_p_n_opor_pdtes;
				    						p_i_opor_pdtes = copia_p_i_opor_pdtes;
				    						p_f_opor_ult = copia_p_f_opor_ult;
				    					
									}	
			
			#endregion

					#region DATOS_FACTURAS
			
			[Nombre("GGCLIPR_TCH_PKG.DATOS_FACTURAS")]
						public delegate void __DATOS_FACTURAS_VVNVVVVoNoNoNoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER(8)] int? p_ggclipr_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(6)] string p_factutipo_cod, 
							[VARCHAR2(4)] string p_tefect_imp, 
							[VARCHAR2(4000)] string p_opcion, 
							[NUMBER(14, 4)] out decimal? p_i_pendiente, 
							[NUMBER(14, 4)] out decimal? p_i_retrasado, 
							[NUMBER(14, 4)] out decimal? p_i_impagado, 
							[VARCHAR2(4000)] out string p_mensaje_error);

						/// <summary>
			/// Llama a DATOS_FACTURAS.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versin sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void DATOS_FACTURAS(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				string p_emp_cod, 
				string p_factutipo_cod, 
				string p_tefect_imp, 
				string p_opcion, 
				out decimal? p_i_pendiente, 
				out decimal? p_i_retrasado, 
				out decimal? p_i_impagado, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DATOS_FACTURAS_VVNVVVVoNoNoNoV v_datos_facturas;
				try {
					v_datos_facturas = Funcion.Crear<__DATOS_FACTURAS_VVNVVVVoNoNoNoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_FACTURAS");
				}
								try {
				v_datos_facturas(p_transaccion, 
					p_empgrupo_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_emp_cod, 
					p_factutipo_cod, 
					p_tefect_imp, 
					p_opcion, 
					out p_i_pendiente, 
					out p_i_retrasado, 
					out p_i_impagado, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_FACTURAS");
				}
							}
			
							/// <summary>
				/// Llama a DATOS_FACTURAS y eleva una excepcin en caso de error. Utiliza la versin 
				/// sobrecargada (con el parmetro p_mensaje_error) para llamar a la versin original.
				/// </summary>
				public static void DATOS_FACTURAS(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[NUMBER(8)] int? p_ggclipr_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(6)] string p_factutipo_cod, 
					[VARCHAR2(4)] string p_tefect_imp, 
					[VARCHAR2(4000)] string p_opcion, 
					[NUMBER(14, 4)] out decimal? p_i_pendiente, 
					[NUMBER(14, 4)] out decimal? p_i_retrasado, 
					[NUMBER(14, 4)] out decimal? p_i_impagado)
				{
												decimal? copia_p_i_pendiente;
										    							decimal? copia_p_i_retrasado;
										    							decimal? copia_p_i_impagado;
										    
					string p_mensaje_error;

					DATOS_FACTURAS(p_transaccion, 
						p_empgrupo_cod, 
						p_tip_vc, 
						p_ggclipr_cod, 
						p_emp_cod, 
						p_factutipo_cod, 
						p_tefect_imp, 
						p_opcion, 
						out copia_p_i_pendiente, 
						out copia_p_i_retrasado, 
						out copia_p_i_impagado,
						out p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
						throw new SpyroException(p_mensaje_error, "GGCLIPR_TCH_PKG.DATOS_FACTURAS");

											p_i_pendiente = copia_p_i_pendiente;
				    						p_i_retrasado = copia_p_i_retrasado;
				    						p_i_impagado = copia_p_i_impagado;
				    					
									}	
			
			#endregion

					#region DATOS_GGOFECAB
			
			[Nombre("GGCLIPR_TCH_PKG.DATOS_GGOFECAB")]
						public delegate void __DATOS_GGOFECAB_VVNVVVDVVVoNoNoNoNoDoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER(8)] int? p_ggclipr_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(8)] string p_ggofetip_cod, 
							[VARCHAR2(3)] string p_tipo_doc, 
							[DATE] DateTime? p_f_referencia, 
							[VARCHAR2(4000)] string p_periodo, 
							[VARCHAR2(4000)] string p_calc_i_ofe_pdtes, 
							[VARCHAR2(4000)] string p_opcion, 
							[NUMBER] out decimal? p_n_ofe_total, 
							[NUMBER(14, 2)] out decimal? p_i_ofe_total, 
							[NUMBER] out decimal? p_n_ofe_pdtes, 
							[NUMBER(14, 2)] out decimal? p_i_ofe_pdtes, 
							[DATE] out DateTime? p_f_ofe_ult, 
							[VARCHAR2(4000)] out string p_mensaje_error);

						/// <summary>
			/// Llama a DATOS_GGOFECAB.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versin sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void DATOS_GGOFECAB(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				string p_emp_cod, 
				string p_ggofetip_cod, 
				string p_tipo_doc, 
				DateTime? p_f_referencia, 
				string p_periodo, 
				string p_calc_i_ofe_pdtes, 
				string p_opcion, 
				out decimal? p_n_ofe_total, 
				out decimal? p_i_ofe_total, 
				out decimal? p_n_ofe_pdtes, 
				out decimal? p_i_ofe_pdtes, 
				out DateTime? p_f_ofe_ult, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DATOS_GGOFECAB_VVNVVVDVVVoNoNoNoNoDoV v_datos_ggofecab;
				try {
					v_datos_ggofecab = Funcion.Crear<__DATOS_GGOFECAB_VVNVVVDVVVoNoNoNoNoDoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_GGOFECAB");
				}
								try {
				v_datos_ggofecab(p_transaccion, 
					p_empgrupo_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_emp_cod, 
					p_ggofetip_cod, 
					p_tipo_doc, 
					p_f_referencia, 
					p_periodo, 
					p_calc_i_ofe_pdtes, 
					p_opcion, 
					out p_n_ofe_total, 
					out p_i_ofe_total, 
					out p_n_ofe_pdtes, 
					out p_i_ofe_pdtes, 
					out p_f_ofe_ult, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_GGOFECAB");
				}
							}
			
							/// <summary>
				/// Llama a DATOS_GGOFECAB y eleva una excepcin en caso de error. Utiliza la versin 
				/// sobrecargada (con el parmetro p_mensaje_error) para llamar a la versin original.
				/// </summary>
				public static void DATOS_GGOFECAB(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[NUMBER(8)] int? p_ggclipr_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[VARCHAR2(8)] string p_ggofetip_cod, 
					[VARCHAR2(3)] string p_tipo_doc, 
					[DATE] DateTime? p_f_referencia, 
					[VARCHAR2(4000)] string p_periodo, 
					[VARCHAR2(4000)] string p_calc_i_ofe_pdtes, 
					[VARCHAR2(4000)] string p_opcion, 
					[NUMBER] out decimal? p_n_ofe_total, 
					[NUMBER(14, 2)] out decimal? p_i_ofe_total, 
					[NUMBER] out decimal? p_n_ofe_pdtes, 
					[NUMBER(14, 2)] out decimal? p_i_ofe_pdtes, 
					[DATE] out DateTime? p_f_ofe_ult)
				{
												decimal? copia_p_n_ofe_total;
										    							decimal? copia_p_i_ofe_total;
										    							decimal? copia_p_n_ofe_pdtes;
										    							decimal? copia_p_i_ofe_pdtes;
										    							DateTime? copia_p_f_ofe_ult;
										    
					string p_mensaje_error;

					DATOS_GGOFECAB(p_transaccion, 
						p_empgrupo_cod, 
						p_tip_vc, 
						p_ggclipr_cod, 
						p_emp_cod, 
						p_ggofetip_cod, 
						p_tipo_doc, 
						p_f_referencia, 
						p_periodo, 
						p_calc_i_ofe_pdtes, 
						p_opcion, 
						out copia_p_n_ofe_total, 
						out copia_p_i_ofe_total, 
						out copia_p_n_ofe_pdtes, 
						out copia_p_i_ofe_pdtes, 
						out copia_p_f_ofe_ult,
						out p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
						throw new SpyroException(p_mensaje_error, "GGCLIPR_TCH_PKG.DATOS_GGOFECAB");

											p_n_ofe_total = copia_p_n_ofe_total;
				    						p_i_ofe_total = copia_p_i_ofe_total;
				    						p_n_ofe_pdtes = copia_p_n_ofe_pdtes;
				    						p_i_ofe_pdtes = copia_p_i_ofe_pdtes;
				    						p_f_ofe_ult = copia_p_f_ofe_ult;
				    					
									}	
			
			#endregion

					#region DATOS_GGPEDCAB
			
			[Nombre("GGCLIPR_TCH_PKG.DATOS_GGPEDCAB")]
						public delegate void __DATOS_GGPEDCAB_VVNVDVVVoNoNoNoNoDoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER(8)] int? p_ggclipr_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[DATE] DateTime? p_f_referencia, 
							[VARCHAR2(4000)] string p_periodo, 
							[VARCHAR2(4000)] string p_calc_i_ped_pdtes, 
							[VARCHAR2(4000)] string p_opcion, 
							[NUMBER] out decimal? p_n_ped_total, 
							[NUMBER(14, 2)] out decimal? p_imp_ped_total, 
							[NUMBER] out decimal? p_n_ped_pdtes, 
							[NUMBER(14, 2)] out decimal? p_i_ped_pdtes, 
							[DATE] out DateTime? p_f_ped_ult, 
							[VARCHAR2(4000)] out string p_mensaje_error);

						/// <summary>
			/// Llama a DATOS_GGPEDCAB.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versin sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void DATOS_GGPEDCAB(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				string p_emp_cod, 
				DateTime? p_f_referencia, 
				string p_periodo, 
				string p_calc_i_ped_pdtes, 
				string p_opcion, 
				out decimal? p_n_ped_total, 
				out decimal? p_imp_ped_total, 
				out decimal? p_n_ped_pdtes, 
				out decimal? p_i_ped_pdtes, 
				out DateTime? p_f_ped_ult, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DATOS_GGPEDCAB_VVNVDVVVoNoNoNoNoDoV v_datos_ggpedcab;
				try {
					v_datos_ggpedcab = Funcion.Crear<__DATOS_GGPEDCAB_VVNVDVVVoNoNoNoNoDoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_GGPEDCAB");
				}
								try {
				v_datos_ggpedcab(p_transaccion, 
					p_empgrupo_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_emp_cod, 
					p_f_referencia, 
					p_periodo, 
					p_calc_i_ped_pdtes, 
					p_opcion, 
					out p_n_ped_total, 
					out p_imp_ped_total, 
					out p_n_ped_pdtes, 
					out p_i_ped_pdtes, 
					out p_f_ped_ult, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_GGPEDCAB");
				}
							}
			
							/// <summary>
				/// Llama a DATOS_GGPEDCAB y eleva una excepcin en caso de error. Utiliza la versin 
				/// sobrecargada (con el parmetro p_mensaje_error) para llamar a la versin original.
				/// </summary>
				public static void DATOS_GGPEDCAB(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[NUMBER(8)] int? p_ggclipr_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[DATE] DateTime? p_f_referencia, 
					[VARCHAR2(4000)] string p_periodo, 
					[VARCHAR2(4000)] string p_calc_i_ped_pdtes, 
					[VARCHAR2(4000)] string p_opcion, 
					[NUMBER] out decimal? p_n_ped_total, 
					[NUMBER(14, 2)] out decimal? p_imp_ped_total, 
					[NUMBER] out decimal? p_n_ped_pdtes, 
					[NUMBER(14, 2)] out decimal? p_i_ped_pdtes, 
					[DATE] out DateTime? p_f_ped_ult)
				{
												decimal? copia_p_n_ped_total;
										    							decimal? copia_p_imp_ped_total;
										    							decimal? copia_p_n_ped_pdtes;
										    							decimal? copia_p_i_ped_pdtes;
										    							DateTime? copia_p_f_ped_ult;
										    
					string p_mensaje_error;

					DATOS_GGPEDCAB(p_transaccion, 
						p_empgrupo_cod, 
						p_tip_vc, 
						p_ggclipr_cod, 
						p_emp_cod, 
						p_f_referencia, 
						p_periodo, 
						p_calc_i_ped_pdtes, 
						p_opcion, 
						out copia_p_n_ped_total, 
						out copia_p_imp_ped_total, 
						out copia_p_n_ped_pdtes, 
						out copia_p_i_ped_pdtes, 
						out copia_p_f_ped_ult,
						out p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
						throw new SpyroException(p_mensaje_error, "GGCLIPR_TCH_PKG.DATOS_GGPEDCAB");

											p_n_ped_total = copia_p_n_ped_total;
				    						p_imp_ped_total = copia_p_imp_ped_total;
				    						p_n_ped_pdtes = copia_p_n_ped_pdtes;
				    						p_i_ped_pdtes = copia_p_i_ped_pdtes;
				    						p_f_ped_ult = copia_p_f_ped_ult;
				    					
									}	
			
			#endregion

					#region DATOS_VISITAS
			
			[Nombre("GGCLIPR_TCH_PKG.DATOS_VISITAS")]
						public delegate void __DATOS_VISITAS_VVNVDVVVoNoDoNoVoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER(8)] int? p_ggclipr_cod, 
							[VARCHAR2(4000)] string p_usrtmensa_cond, 
							[DATE] DateTime? p_f_referencia, 
							[VARCHAR2(4000)] string p_periodo, 
							[VARCHAR2(4000)] string p_proceso, 
							[VARCHAR2(4000)] string p_opcion, 
							[NUMBER] out decimal? p_n_visi_total, 
							[DATE] out DateTime? p_f_visi_ult, 
							[NUMBER(8)] out int? p_n_informe_visi_ult, 
							[VARCHAR2(30)] out string p_usrnom_visi_ult, 
							[VARCHAR2(60)] out string p_descriptor_visi_ult, 
							[VARCHAR2(4000)] out string p_mensaje_error);

						/// <summary>
			/// Llama a DATOS_VISITAS.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versin sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void DATOS_VISITAS(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				string p_usrtmensa_cond, 
				DateTime? p_f_referencia, 
				string p_periodo, 
				string p_proceso, 
				string p_opcion, 
				out decimal? p_n_visi_total, 
				out DateTime? p_f_visi_ult, 
				out int? p_n_informe_visi_ult, 
				out string p_usrnom_visi_ult, 
				out string p_descriptor_visi_ult, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__DATOS_VISITAS_VVNVDVVVoNoDoNoVoVoV v_datos_visitas;
				try {
					v_datos_visitas = Funcion.Crear<__DATOS_VISITAS_VVNVDVVVoNoDoNoVoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_VISITAS");
				}
								try {
				v_datos_visitas(p_transaccion, 
					p_empgrupo_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_usrtmensa_cond, 
					p_f_referencia, 
					p_periodo, 
					p_proceso, 
					p_opcion, 
					out p_n_visi_total, 
					out p_f_visi_ult, 
					out p_n_informe_visi_ult, 
					out p_usrnom_visi_ult, 
					out p_descriptor_visi_ult, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.DATOS_VISITAS");
				}
							}
			
							/// <summary>
				/// Llama a DATOS_VISITAS y eleva una excepcin en caso de error. Utiliza la versin 
				/// sobrecargada (con el parmetro p_mensaje_error) para llamar a la versin original.
				/// </summary>
				public static void DATOS_VISITAS(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(1)] string p_tip_vc, 
					[NUMBER(8)] int? p_ggclipr_cod, 
					[VARCHAR2(4000)] string p_usrtmensa_cond, 
					[DATE] DateTime? p_f_referencia, 
					[VARCHAR2(4000)] string p_periodo, 
					[VARCHAR2(4000)] string p_proceso, 
					[VARCHAR2(4000)] string p_opcion, 
					[NUMBER] out decimal? p_n_visi_total, 
					[DATE] out DateTime? p_f_visi_ult, 
					[NUMBER(8)] out int? p_n_informe_visi_ult, 
					[VARCHAR2(30)] out string p_usrnom_visi_ult, 
					[VARCHAR2(60)] out string p_descriptor_visi_ult)
				{
												decimal? copia_p_n_visi_total;
										    							DateTime? copia_p_f_visi_ult;
										    							int? copia_p_n_informe_visi_ult;
										    							string copia_p_usrnom_visi_ult;
										    							string copia_p_descriptor_visi_ult;
										    
					string p_mensaje_error;

					DATOS_VISITAS(p_transaccion, 
						p_empgrupo_cod, 
						p_tip_vc, 
						p_ggclipr_cod, 
						p_usrtmensa_cond, 
						p_f_referencia, 
						p_periodo, 
						p_proceso, 
						p_opcion, 
						out copia_p_n_visi_total, 
						out copia_p_f_visi_ult, 
						out copia_p_n_informe_visi_ult, 
						out copia_p_usrnom_visi_ult, 
						out copia_p_descriptor_visi_ult,
						out p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
						throw new SpyroException(p_mensaje_error, "GGCLIPR_TCH_PKG.DATOS_VISITAS");

											p_n_visi_total = copia_p_n_visi_total;
				    						p_f_visi_ult = copia_p_f_visi_ult;
				    						p_n_informe_visi_ult = copia_p_n_informe_visi_ult;
				    						p_usrnom_visi_ult = copia_p_usrnom_visi_ult;
				    						p_descriptor_visi_ult = copia_p_descriptor_visi_ult;
				    					
									}	
			
			#endregion

					#region GENERAR_DATOS_DERIVADOS
			
			[Nombre("GGCLIPR_TCH_PKG.GENERAR_DATOS_DERIVADOS")]
						public delegate void __GENERAR_DATOS_DERIVADOS_VVNVVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER(8)] int? p_ggclipr_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[VARCHAR2(4000)] string p_mostrar_traza_sn, 
							[VARCHAR2(4000)] string p_opcion);

						/// <summary>
			/// Llama a GENERAR_DATOS_DERIVADOS.
						/// </summary>
			public static void GENERAR_DATOS_DERIVADOS(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				string p_emp_cod, 
				string p_mostrar_traza_sn, 
				string p_opcion,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__GENERAR_DATOS_DERIVADOS_VVNVVV v_generar_datos_derivados;
				try {
					v_generar_datos_derivados = Funcion.Crear<__GENERAR_DATOS_DERIVADOS_VVNVVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.GENERAR_DATOS_DERIVADOS");
				}
								try {
				v_generar_datos_derivados(p_transaccion, 
					p_empgrupo_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_emp_cod, 
					p_mostrar_traza_sn, 
					p_opcion);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.GENERAR_DATOS_DERIVADOS");
				}
							}
			
			
			#endregion

					#region GGCLIPR_GGCLASIF_VALOR
			
			[Nombre("GGCLIPR_TCH_PKG.GGCLIPR_GGCLASIF_VALOR")]
						[return: VARCHAR2(4000)]
						public delegate string __GGCLIPR_GGCLASIF_VALOR_VVNVV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(1)] string p_tip_vc, 
							[NUMBER(8)] int? p_ggclipr_cod, 
							[VARCHAR2(10)] string p_ggclatip_cod, 
							[VARCHAR2(4000)] string p_opcion);

						/// <summary>
			/// Llama a GGCLIPR_GGCLASIF_VALOR.
						/// </summary>
			public static string GGCLIPR_GGCLASIF_VALOR(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_tip_vc, 
				int? p_ggclipr_cod, 
				string p_ggclatip_cod, 
				string p_opcion,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__GGCLIPR_GGCLASIF_VALOR_VVNVV v_ggclipr_ggclasif_valor;
				try {
					v_ggclipr_ggclasif_valor = Funcion.Crear<__GGCLIPR_GGCLASIF_VALOR_VVNVV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.GGCLIPR_GGCLASIF_VALOR");
				}
									string v_resultado;
								try {
				v_resultado = v_ggclipr_ggclasif_valor(p_transaccion, 
					p_empgrupo_cod, 
					p_tip_vc, 
					p_ggclipr_cod, 
					p_ggclatip_cod, 
					p_opcion);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.GGCLIPR_GGCLASIF_VALOR");
				}
									return v_resultado;
							}
			
			
			#endregion

					#region KMS_A_LA_REDONDA
			
			[Nombre("GGCLIPR_TCH_PKG.KMS_A_LA_REDONDA")]
						[return: NUMBER]
						public delegate decimal? __KMS_A_LA_REDONDA_NNNN(
							System.Data.IDbTransaction p_transaccion, 
							[NUMBER] decimal? p_latitud_ori, 
							[NUMBER] decimal? p_longitud_ori, 
							[NUMBER] decimal? p_latitud_des, 
							[NUMBER] decimal? p_longitud_des);

						/// <summary>
			/// Llama a KMS_A_LA_REDONDA.
						/// </summary>
			public static decimal? KMS_A_LA_REDONDA(
				System.Data.IDbTransaction p_transaccion, 
				decimal? p_latitud_ori, 
				decimal? p_longitud_ori, 
				decimal? p_latitud_des, 
				decimal? p_longitud_des,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__KMS_A_LA_REDONDA_NNNN v_kms_a_la_redonda;
				try {
					v_kms_a_la_redonda = Funcion.Crear<__KMS_A_LA_REDONDA_NNNN>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.KMS_A_LA_REDONDA");
				}
									decimal? v_resultado;
								try {
				v_resultado = v_kms_a_la_redonda(p_transaccion, 
					p_latitud_ori, 
					p_longitud_ori, 
					p_latitud_des, 
					p_longitud_des);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.KMS_A_LA_REDONDA");
				}
									return v_resultado;
							}
			
			
			#endregion

					#region MODIFICA_CLIENTE
			
			[Nombre("GGCLIPR_TCH_PKG.MODIFICA_CLIENTE")]
						public delegate void __MODIFICA_CLIENTE_VVNVVVVVVoVoV(
							System.Data.IDbTransaction p_transaccion, 
							[VARCHAR2(4)] string p_empgrupo_cod, 
							[VARCHAR2(4)] string p_emp_cod, 
							[NUMBER(8)] int? p_cod, 
							[VARCHAR2(40)] string p_nombre_ant, 
							[VARCHAR2(40)] string p_nombre, 
							[VARCHAR2(4000)] string p_nombre_mod, 
							[VARCHAR2(40)] string p_web_ant, 
							[VARCHAR2(40)] string p_web, 
							[VARCHAR2(4000)] string p_web_mod, 
							[VARCHAR2(4000)] out string p_mensaje_info, 
							[VARCHAR2(4000)] out string p_mensaje_error);

						/// <summary>
			/// Llama a MODIFICA_CLIENTE.
							/// AVISO: El ultimo parametro parece un mensaje a controlar en caso de que
				/// produzca una situacion de error. Recuerda controlarlo o utiliza la versin sobrecargada (sin el
				/// parametro p_mensaje_error) para que se eleve una excepcion de forma automatica.
						/// </summary>
			public static void MODIFICA_CLIENTE(
				System.Data.IDbTransaction p_transaccion, 
				string p_empgrupo_cod, 
				string p_emp_cod, 
				int? p_cod, 
				string p_nombre_ant, 
				string p_nombre, 
				string p_nombre_mod, 
				string p_web_ant, 
				string p_web, 
				string p_web_mod, 
				out string p_mensaje_info, 
				out string p_mensaje_error,
				Funcion.Config _p_config = null)
			{
				var v_conexion = p_transaccion.Connection;
				__MODIFICA_CLIENTE_VVNVVVVVVoVoV v_modifica_cliente;
				try {
					v_modifica_cliente = Funcion.Crear<__MODIFICA_CLIENTE_VVNVVVVVVoVoV>(v_conexion, _p_config);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.MODIFICA_CLIENTE");
				}
								try {
				v_modifica_cliente(p_transaccion, 
					p_empgrupo_cod, 
					p_emp_cod, 
					p_cod, 
					p_nombre_ant, 
					p_nombre, 
					p_nombre_mod, 
					p_web_ant, 
					p_web, 
					p_web_mod, 
					out p_mensaje_info, 
					out p_mensaje_error);
				}
				catch (Exception ex) {
					throw new SpyroException(ex.Message, "GGCLIPR_TCH_PKG.MODIFICA_CLIENTE");
				}
							}
			
							/// <summary>
				/// Llama a MODIFICA_CLIENTE y eleva una excepcin en caso de error. Utiliza la versin 
				/// sobrecargada (con el parmetro p_mensaje_error) para llamar a la versin original.
				/// </summary>
				public static void MODIFICA_CLIENTE(
					System.Data.IDbTransaction p_transaccion, 
					[VARCHAR2(4)] string p_empgrupo_cod, 
					[VARCHAR2(4)] string p_emp_cod, 
					[NUMBER(8)] int? p_cod, 
					[VARCHAR2(40)] string p_nombre_ant, 
					[VARCHAR2(40)] string p_nombre, 
					[VARCHAR2(4000)] string p_nombre_mod, 
					[VARCHAR2(40)] string p_web_ant, 
					[VARCHAR2(40)] string p_web, 
					[VARCHAR2(4000)] string p_web_mod, 
					[VARCHAR2(4000)] out string p_mensaje_info)
				{
												string copia_p_mensaje_info;
										    
					string p_mensaje_error;

					MODIFICA_CLIENTE(p_transaccion, 
						p_empgrupo_cod, 
						p_emp_cod, 
						p_cod, 
						p_nombre_ant, 
						p_nombre, 
						p_nombre_mod, 
						p_web_ant, 
						p_web, 
						p_web_mod, 
						out copia_p_mensaje_info,
						out p_mensaje_error);

					if (!string.IsNullOrEmpty(p_mensaje_error))
						throw new SpyroException(p_mensaje_error, "GGCLIPR_TCH_PKG.MODIFICA_CLIENTE");

											p_mensaje_info = copia_p_mensaje_info;
				    					
									}	
			
			#endregion

			}
}